#ifndef _STRINGPACK_H
#define _STRINGPACK_H

#include <string>
#include <map>
#include <utility>

using namespace std;

class StringPack {
  
 public:
  StringPack();
  ~StringPack();


  void addString(string key, string &value);
  void addString(string key, const string &value);
  void addInt(string key, int value);
  void addDouble(string key, double value);

  const string getString(string key);
  int getInt(string key);
  double getDouble(string key);

  // just easier versions of the above
  const string getString(char *key);
  int getInt(char *key);
  double getDouble(char *key);
  
  string serialize();
  void deserialize(string &encstr);


 protected:
  map <string, string>pairs;
  string str_rep;

  // tells whether we need to update str_rep, during serialize()
  bool changed;
};


#endif
