
/* A Bison parser, made from ug_read.y
   by GNU bison 1.29.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse ug_readparse
#define yylex ug_readlex
#define yyerror ug_readerror
#define yylval ug_readlval
#define yychar ug_readchar
#define yydebug ug_readdebug
#define yynerrs ug_readnerrs
# define	TOK_LAYER	257
# define	TOK_DEFINITION	258
# define	TOK_END	259
# define	TOK_VERT	260
# define	TOK_WIRE	261
# define	TOK_FACE	262
# define	TOK_INSTANCE	263
# define	TOK_OC	264
# define	TOK_CC	265
# define	TOK_OS	266
# define	TOK_CS	267
# define	TOK_OP	268
# define	TOK_CP	269
# define	TOK_EOL	270
# define	TOK_COLOR	271
# define	TOK_INCLUDE	272
# define	DOUBLE	273
# define	TRANSFORM	274
# define	IDENT	275
# define	ARRAY	276

#line 1 "ug_read.y"


/**  File:        ug_read.y --> ug_read.tab.c
 **  Created by:  wml
 **  Modified by: wml
 **  Invocation:  bison -p ug_read -d ug_read.y
 **  Description: Unigraphics file parser.  Reads a ug file into a data-
 **    structure and returns.
 **/

#include <iostream>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <malloc.h>

  //#include <list.h>

#include "../CADlib2/CADstuff.h"
#include "ug_write.h"

/**  struct:      ug_read_str
 **  Description: Allows for a list of strings to be held while reading in data
 **    from the file.  This is mainly designed to keep a list of vertices for a
 **    wire or face as it's being read in.
 **/
struct ug_read_str{
  char *str;            /** Data. **/
  ug_read_str *next;    /** Pointer to the next string in the list. **/
};

/**  struct:      ug_read_double
 **  Description: Linked list of doubles.  Used for keeping track of the points
 **    of a graphic to map onto a face.
 **/
struct ug_read_double{
  double x, y;          /** X, Y coordinates. **/
  ug_read_double *next; /** Next pair in the list. **/
};

/** External variables. **/
extern unsigned int line;    /** Line counter. **/
extern FILE *ug_readin;      /** Input file pointer. **/

ug_CADSpace *ucs;            /** Structure to store file into. **/
char *region_name;           /** Current region. **/
int unnamed_unit;            /** Number of unnamed wire/face. **/

/** Lexical Analyzer **/
extern int ug_readlex();

/**  Function:    ug_readerror(*str)
 **  Description: yyerror(*str), modified for the purposes of this project.
 **/
void ug_readerror(char *str)
{
  cerr << "UG_READ Error: " << str << endl;
  return;
}


#line 63 "ug_read.y"
typedef union{
  double num;                 //** All numbers stored as double floats. **/
  char *str;                  //** Strings, identifiers, etc. **/
  struct ug_read_str *urs;    //** NULL-terminated list of strings. **/
  struct ug_read_double *urd; //** NULL-terminated list of doubles. **/
} YYSTYPE;
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

#include <stdio.h>



#define	YYFINAL		92
#define	YYFLAG		-32768
#define	YYNTBASE	24

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 276 ? yytranslate[x] : 45)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      23,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22
};

#if YYDEBUG != 0
static const short yyprhs[] =
{
       0,     0,     1,     4,     6,     8,    10,    12,    14,    16,
      18,    20,    22,    24,    26,    29,    33,    34,    37,    40,
      43,    46,    50,    51,    54,    57,    60,    63,    70,    72,
      77,    81,    85,    88,    95,   101,   109,   117,   128,   129,
     132,   141,   142,   146,   147,   149,   150,   152,   153,   155,
     156
};
static const short yyrhs[] =
{
      -1,    24,    25,     0,    30,     0,    34,     0,    35,     0,
      36,     0,    37,     0,    39,     0,    31,     0,    32,     0,
      33,     0,    28,     0,    26,     0,     1,    23,     0,    10,
      27,    11,     0,     0,    27,    26,     0,    27,    21,     0,
      27,    19,     0,    27,    20,     0,    14,    29,    11,     0,
       0,    29,    28,     0,    29,    19,     0,    29,    21,     0,
      29,    20,     0,     3,    21,    19,    19,    19,    16,     0,
      22,     0,    10,    17,    19,    11,     0,    18,    21,    16,
       0,     4,    21,    16,     0,     5,    16,     0,     6,    21,
      19,    19,    19,    16,     0,     6,    21,    19,    19,    16,
       0,     7,    44,    14,    38,    15,    44,    16,     0,     8,
      44,    14,    38,    15,    44,    16,     0,     8,    44,    14,
      38,    15,    44,    12,    40,    13,    16,     0,     0,    21,
      38,     0,     9,    41,    14,    21,    42,    43,    15,    16,
       0,     0,    19,    19,    40,     0,     0,    21,     0,     0,
      21,     0,     0,    20,     0,     0,    21,     0
};

#endif

#if YYDEBUG != 0
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,    84,    85,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   109,   114,   115,   116,   117,
     118,   124,   129,   130,   131,   132,   133,   139,   147,   159,
     166,   174,   185,   194,   199,   211,   265,   321,   384,   385,
     398,   427,   430,   441,   442,   444,   445,   447,   448,   451,
     452
};
#endif


#if YYDEBUG != 0 || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "TOK_LAYER", "TOK_DEFINITION", "TOK_END", 
  "TOK_VERT", "TOK_WIRE", "TOK_FACE", "TOK_INSTANCE", "TOK_OC", "TOK_CC", 
  "TOK_OS", "TOK_CS", "TOK_OP", "TOK_CP", "TOK_EOL", "TOK_COLOR", 
  "TOK_INCLUDE", "DOUBLE", "TRANSFORM", "IDENT", "ARRAY", "'\\n'", "file", 
  "line", "CommentStmt", "CommentInter", "EscapeText", "EscapeInternal", 
  "LayerData", "ArrayDef", "ColorDef", "IncludeStmt", "RegionDef", 
  "RegionEnd", "VertexDef", "WireDef", "VertList", "InstanceDef", 
  "GraphicCoords", "Iident", "Icolor", "Itransform", "WireColor", NULL
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    24,    24,    25,    25,    25,    25,    25,    25,    25,
      25,    25,    25,    25,    25,    26,    27,    27,    27,    27,
      27,    28,    29,    29,    29,    29,    29,    30,    31,    32,
      33,    34,    35,    36,    36,    37,    37,    37,    38,    38,
      39,    40,    40,    41,    41,    42,    42,    43,    43,    44,
      44
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     3,     0,     2,     2,     2,
       2,     3,     0,     2,     2,     2,     2,     6,     1,     4,
       3,     3,     2,     6,     5,     7,     7,    10,     0,     2,
       8,     0,     3,     0,     1,     0,     1,     0,     1,     0,
       1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       1,     0,     0,     0,     0,     0,     0,    49,    49,    43,
      16,    22,     0,    28,     2,    13,    12,     3,     9,    10,
      11,     4,     5,     6,     7,     8,    14,     0,     0,    32,
       0,    50,     0,     0,    44,     0,     0,     0,     0,     0,
       0,    31,     0,    38,    38,     0,     0,    16,    15,    19,
      20,    18,    17,    21,    24,    26,    25,    23,    30,     0,
       0,    38,     0,     0,    45,    29,     0,    34,     0,    39,
      49,    49,    46,    47,    27,    33,     0,     0,    48,     0,
      35,    41,    36,     0,     0,     0,    40,    41,     0,    42,
      37,     0,     0
};

static const short yydefgoto[] =
{
       1,    14,    15,    37,    16,    38,    17,    18,    19,    20,
      21,    22,    23,    24,    62,    25,    85,    35,    73,    79,
      32
};

static const short yypact[] =
{
  -32768,     1,   -11,     7,    12,    -3,    13,    15,    15,    17,
       5,-32768,    18,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,    21,    25,-32768,
      23,-32768,    29,    30,-32768,    31,    27,     6,    10,    32,
      28,-32768,    33,    34,    34,    35,    26,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    38,
      16,    34,    36,    39,    37,-32768,    43,-32768,    44,-32768,
      15,    15,-32768,    41,-32768,-32768,    48,     2,-32768,    50,
  -32768,    47,-32768,    51,    49,    40,-32768,    47,    53,-32768,
  -32768,    70,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,    42,-32768,    11,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,   -41,-32768,   -37,-32768,-32768,-32768,
      -8
};


#define	YYLAST		79


static const short yytable[] =
{
      33,    91,     2,    63,     3,     4,     5,     6,     7,     8,
       9,    10,    26,    29,    81,    11,    47,    48,    82,    12,
      69,    53,    36,    13,    11,    49,    50,    51,    27,    54,
      55,    56,    67,    28,    30,    68,    31,    65,    34,    39,
      40,    41,    42,    43,    44,    45,    46,    59,    58,    57,
      89,    70,    60,    88,    71,    61,    64,    66,    72,    74,
      75,    78,    76,    77,    80,    83,    84,    86,    87,    90,
      92,     0,     0,     0,     0,     0,     0,     0,     0,    52
};

static const short yycheck[] =
{
       8,     0,     1,    44,     3,     4,     5,     6,     7,     8,
       9,    10,    23,    16,    12,    14,    10,    11,    16,    18,
      61,    11,    17,    22,    14,    19,    20,    21,    21,    19,
      20,    21,    16,    21,    21,    19,    21,    11,    21,    21,
      19,    16,    19,    14,    14,    14,    19,    19,    16,    38,
      87,    15,    19,    13,    15,    21,    21,    19,    21,    16,
      16,    20,    70,    71,    16,    15,    19,    16,    19,    16,
       0,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison/bison.simple"

/* Skeleton output parser for bison,
   Copyright 1984, 1989, 1990, 2000, 2001 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
# ifdef alloca
#  define YYSTACK_USE_ALLOCA 1
# else /* alloca not defined */
#  ifdef __GNUC__
#   define YYSTACK_USE_ALLOCA 1
#   define alloca __builtin_alloca
#  else /* not GNU C.  */
#   if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#    define YYSTACK_USE_ALLOCA 1
#    include <alloca.h>
#   else /* not sparc */
     /* We think this test detects Watcom and Microsoft C.  */
     /* This used to test MSDOS, but that is a bad idea since that
	symbol is in the user namespace.  */
#    if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#     if 0
       /* No need for malloc.h, which pollutes the namespace; instead,
	  just don't use alloca.  */
#      include <malloc.h>
#     endif
#    else /* not MSDOS, or __TURBOC__ */
#     if defined(_AIX)
       /* I don't know what this was needed for, but it pollutes the
	  namespace.  So I turned it off.  rms, 2 May 1997.  */
       /* #include <malloc.h>  */
 #pragma alloca
#      define YYSTACK_USE_ALLOCA 1
#     else /* not MSDOS, or __TURBOC__, or _AIX */
#      if 0
	/* haible@ilog.fr says this works for HPUX 9.05 and up, and on
	   HPUX 10.  Eventually we can turn this on.  */
#       ifdef __hpux
#        define YYSTACK_USE_ALLOCA 1
#        define alloca __builtin_alloca
#  	endif /* __hpux */
#      endif
#     endif /* not _AIX */
#    endif /* not MSDOS, or __TURBOC__ */
#   endif /* not sparc */
#  endif /* not GNU C */
# endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#if YYSTACK_USE_ALLOCA
# define YYSTACK_ALLOC alloca
#else
# define YYSTACK_ALLOC malloc
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG
# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    fprintf Args;				\
} while (0)
/* Nonzero means print parse trace. [The following comment makes no
   sense to me.  Could someone clarify it?  --akim] Since this is
   uninitialized, it does not stop multiple parsers from coexisting.
   */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).  */
#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
# define __yy_memcpy(To, From, Count)	__builtin_memcpy (To, From, Count)
#else				/* not GNU C or C++ */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
# ifndef __cplusplus
__yy_memcpy (to, from, count)
     char *to;
     const char *from;
     unsigned int count;
# else /* __cplusplus */
__yy_memcpy (char *to, const char *from, unsigned int count)
# endif
{
  register const char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif

#line 212 "/usr/local/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# ifdef __cplusplus
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else /* !__cplusplus */
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif /* !__cplusplus */
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define _YY_DECL_VARIABLES				\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
_YY_DECL_VARIABLES				\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
_YY_DECL_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yysv': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
# if YYLSP_NEEDED
  YYLTYPE yyloc;
# endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;
  
 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack. Use copies of
	 these so that the &'s don't force the real ones into memory.
	 */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#if YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of the
	 data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow ("parser stack overflow",
		  &yyss1, size * sizeof (*yyssp),
		  &yyvs1, size * sizeof (*yyvsp),
		  &yyls1, size * sizeof (*yylsp),
		  &yystacksize);
# else
      yyoverflow ("parser stack overflow",
		  &yyss1, size * sizeof (*yyssp),
		  &yyvs1, size * sizeof (*yyvsp),
		  &yystacksize);
# endif

      yyss = yyss1; yyvs = yyvs1;
# if YYLSP_NEEDED
      yyls = yyls1;
# endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror ("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
# if YYLSP_NEEDED
	      free (yyls);
# endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
# ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
# endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
# if YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
# endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#if YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %d\n", yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 14:
#line 101 "ug_read.y"
{
		  fprintf(stderr, "Recovering from error on line: %d\n", line);
		  yyerrok;
		;
    break;}
case 15:
#line 109 "ug_read.y"
{ fprintf(stderr, "Got a comment\n"); ;
    break;}
case 17:
#line 115 "ug_read.y"
{ ;
    break;}
case 18:
#line 116 "ug_read.y"
{ free(yyvsp[0].str); ;
    break;}
case 19:
#line 117 "ug_read.y"
{ ;
    break;}
case 20:
#line 118 "ug_read.y"
{ free(yyvsp[0].str); ;
    break;}
case 21:
#line 124 "ug_read.y"
{ fprintf(stderr, "Got an escape\n"); ;
    break;}
case 23:
#line 130 "ug_read.y"
{ ;
    break;}
case 24:
#line 131 "ug_read.y"
{ ;
    break;}
case 25:
#line 132 "ug_read.y"
{ free(yyvsp[0].str); ;
    break;}
case 26:
#line 133 "ug_read.y"
{ free(yyvsp[0].str); ;
    break;}
case 27:
#line 139 "ug_read.y"
{
                  ucs->addNewLayer(yyvsp[-4].str, yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, -1);
		  delete[] yyvsp[-4].str;
		;
    break;}
case 28:
#line 147 "ug_read.y"
{
		  cerr << "Array: " << yyvsp[0].str << endl;
		  delete[] yyvsp[0].str;
		;
    break;}
case 29:
#line 159 "ug_read.y"
{
		  ucs->colorFirstColorless( (int) yyvsp[-1].num);
		;
    break;}
case 30:
#line 166 "ug_read.y"
{
		  ucs->include(yyvsp[-1].str, ucs->getRegion(region_name));
		  free(yyvsp[-1].str);
		;
    break;}
case 31:
#line 174 "ug_read.y"
{
		  assert(region_name == NULL);
		  region_name = yyvsp[-1].str;
		  ucs->addNewRegion(region_name);
		;
    break;}
case 32:
#line 185 "ug_read.y"
{
		  assert(region_name != NULL);
		  delete[] region_name;
		  region_name = NULL;
		;
    break;}
case 33:
#line 194 "ug_read.y"
{
		  /** 3D case. **/
		  ucs->addNewVert(yyvsp[-4].str, yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, ucs->getRegion(region_name));
		  delete[] yyvsp[-4].str;
		;
    break;}
case 34:
#line 199 "ug_read.y"
{
		  /** 2D case. **/
		  ucs->addNewVert(yyvsp[-3].str, yyvsp[-2].num, yyvsp[-1].num, 0, ucs->getRegion(region_name));
		  delete[] yyvsp[-3].str;
		;
    break;}
case 35:
#line 211 "ug_read.y"
{
		  char issue_buff[256];
		  ug_read_str *urs1, *urs2 = NULL;
		  ug_wire *w;

		  if(yyvsp[-3].urs == NULL){
		    /** If there are no vertices, report the error. **/
		    cerr << "Empty wire: " << yyvsp[-5].str << endl;
		  }else{

		    /** Some wires and faces are unnamed.  Give them a default
		        name. **/
		    if(yyvsp[-5].str == NULL){
		      sprintf(issue_buff, "unnamed_unit_%d", unnamed_unit);
		      ++unnamed_unit;
		      yyvsp[-5].str = strdup(issue_buff);
		    }

		    /** Get the next wire from the datastructure. **/
		    w = ucs->newWire(yyvsp[-5].str);
		    for(urs1 = yyvsp[-3].urs; urs1 != NULL; urs1 = urs1->next){
		      /** For each vertex, add it to the list in the wire. **/
		      if(urs2 != NULL){
			delete[] urs2->str;
			delete urs2;
		      }
		      urs2 = urs1;
		      w->pushVert(ucs->getVertByName(urs1->str));
		    }

		    /** Add the wire to the datastructure. **/
		    if(ucs->getLayer(yyvsp[-1].str) == NULL){
		      /** There was no such layer. **/
		      if(yyvsp[-1].str == NULL){
		        sprintf(issue_buff, "Wire %s had no layer.  %s",
			        yyvsp[-5].str, "Adding it to EMPTY_LAYER");
			ug_readerror(issue_buff);
		      }else{
		        sprintf(issue_buff, "Wire %s had a bad layer.  %s",
			        yyvsp[-5].str, "Adding it to EMPTY_LAYER");
			ug_readerror(issue_buff);
			free(yyvsp[-1].str);
		      }
		      yyvsp[-1].str = strdup("EMPTY_LAYER");
		      if(ucs->getLayer(yyvsp[-1].str) == NULL)
		        ucs->addNewLayer(yyvsp[-1].str, 0.500, 0.500, 0.500, -1);
		    }
		    ucs->addWire(w, ucs->getLayer(yyvsp[-1].str),
				 ucs->getRegion(region_name));
		  }
		  delete[] yyvsp[-1].str;
		  delete[] yyvsp[-5].str;

		;
    break;}
case 36:
#line 265 "ug_read.y"
{
		  char issue_buff[256];
		  ug_read_str *urs1, *urs2 = NULL;
		  ug_wire *f;

		  if(yyvsp[-3].urs == NULL){
		    /** If there are no vertices, report the error. **/
		    cerr << "Empty face: " << yyvsp[-5].str << endl;
		  }else{

		    /** Some wires and faces are unnamed.  Give them a default
		        name. **/
		    if(yyvsp[-5].str == NULL){
		      sprintf(issue_buff, "unnamed_unit_%d", unnamed_unit);
		      ++unnamed_unit;
		      yyvsp[-5].str = strdup(issue_buff);
		    }

		    /** Get the next face from the datastructure. **/
		    f = ucs->newWire(yyvsp[-5].str);
		    for(urs1 = yyvsp[-3].urs; urs1 != NULL; urs1 = urs1->next){
		      /** For each vertex, add it to the list in the wire. **/
		      if(urs2 != NULL){
			delete[] urs2->str;
			delete urs2;
		      }
		      urs2 = urs1;
		      f->pushVert(ucs->getVertByName(urs1->str));
		    }

		    /** Turn the wire into a face (closed polygon). **/
		    f->close();
		    /** Add the wire to the datastructure. **/
		    if(ucs->getLayer(yyvsp[-1].str) == NULL){
		      /** There was no such layer. **/
		      if(yyvsp[-1].str == NULL){
		        sprintf(issue_buff, "Face %s had no layer.  %s",
			        yyvsp[-5].str, "Adding it to EMPTY_LAYER");
			ug_readerror(issue_buff);
		      }else{
		        sprintf(issue_buff, "Face %s had a bad layer.  %s",
			        yyvsp[-5].str, "Adding it to EMPTY_LAYER");
			ug_readerror(issue_buff);
			free(yyvsp[-1].str);
		      }
		      yyvsp[-1].str = strdup("EMPTY_LAYER");
		      if(ucs->getLayer(yyvsp[-1].str) == NULL)
		        ucs->addNewLayer(yyvsp[-1].str, 0.500, 0.500, 0.500, -1);
		    }
		    ucs->addWire(f, ucs->getLayer(yyvsp[-1].str),
				 ucs->getRegion(region_name));
		  }
		  delete[] yyvsp[-1].str;
		  delete[] yyvsp[-5].str;

		;
    break;}
case 37:
#line 322 "ug_read.y"
{

		  char issue_buff[256];
		  ug_read_str *urs1, *urs2 = NULL;
		  ug_wire *f;

		  if(yyvsp[-6].urs == NULL){
		    /** If there are no vertices, report the error. **/
		    cerr << "Empty face: " << yyvsp[-8].str << endl;
		  }else{

		    /** Some wires and faces are unnamed.  Give them a default
		        name. **/
		    if(yyvsp[-8].str == NULL){
		      sprintf(issue_buff, "unnamed_unit_%d", unnamed_unit);
		      ++unnamed_unit;
		      yyvsp[-8].str = strdup(issue_buff);
		    }

		    /** Get the next face from the datastructure. **/
		    f = ucs->newWire(yyvsp[-8].str);
		    for(urs1 = yyvsp[-6].urs; urs1 != NULL; urs1 = urs1->next){
		      /** For each vertex, add it to the list in the wire. **/
		      if(urs2 != NULL){
			delete[] urs2->str;
			delete urs2;
		      }
		      urs2 = urs1;
		      f->pushVert(ucs->getVertByName(urs1->str));
		    }

		    /** Turn the wire into a face (closed polygon). **/
		    f->close();
		    /** Add the wire to the datastructure. **/
		    if(ucs->getLayer(yyvsp[-4].str) == NULL){
		      /** There was no such layer. **/
		      if(yyvsp[-4].str == NULL){
		        sprintf(issue_buff, "Face %s had no layer.  %s",
			        yyvsp[-8].str, "Adding it to EMPTY_LAYER");
			ug_readerror(issue_buff);
		      }else{
		        sprintf(issue_buff, "Face %s had a bad layer.  %s",
			        yyvsp[-8].str, "Adding it to EMPTY_LAYER");
			ug_readerror(issue_buff);
			free(yyvsp[-4].str);
		      }
		      yyvsp[-4].str = strdup("EMPTY_LAYER");
		      if(ucs->getLayer(yyvsp[-4].str) == NULL)
		        ucs->addNewLayer(yyvsp[-4].str, 0.500, 0.500, 0.500, -1);
		    }
		    ucs->addWire(f, ucs->getLayer(yyvsp[-4].str),
				 ucs->getRegion(region_name));
		  }
		  delete[] yyvsp[-4].str;
		  delete[] yyvsp[-8].str;

		;
    break;}
case 38:
#line 384 "ug_read.y"
{ yyval.urs = NULL; ;
    break;}
case 39:
#line 385 "ug_read.y"
{
		  ug_read_str *s;
		  s       = new ug_read_str;
		  s->str  = yyvsp[-1].str;
		  s->next = yyvsp[0].urs;
		  yyval.urs      = s;
		;
    break;}
case 40:
#line 399 "ug_read.y"
{

		  ug_instance *i;
		  i = ucs->addNewInstance(ucs->getRegion(region_name));
		  if(yyvsp[-6].str != NULL){
		    i->setName(yyvsp[-6].str);
		    free(yyvsp[-6].str);
		  }

		  i->setObject(ucs->getRegion(yyvsp[-4].str));
		  free(yyvsp[-4].str);

		  if(yyvsp[-3].str != NULL){
		    i->setLayer(ucs->getLayer(yyvsp[-3].str));
		    free(yyvsp[-3].str);
		  }

		  if(yyvsp[-2].str != NULL){
		    i->makeTransform(yyvsp[-2].str);
		    free(yyvsp[-2].str);
		  }

		;
    break;}
case 41:
#line 427 "ug_read.y"
{
		  yyval.urd = NULL;
		;
    break;}
case 42:
#line 430 "ug_read.y"
{
		  yyval.urd = new ug_read_double;
		  yyval.urd->x    = yyvsp[-2].num;
		  yyval.urd->y    = yyvsp[-1].num;
		  yyval.urd->next = yyvsp[0].urd;
		;
    break;}
case 43:
#line 441 "ug_read.y"
{ yyval.str = NULL; ;
    break;}
case 44:
#line 442 "ug_read.y"
{ yyval.str = yyvsp[0].str; ;
    break;}
case 45:
#line 444 "ug_read.y"
{ yyval.str = NULL; ;
    break;}
case 46:
#line 445 "ug_read.y"
{ yyval.str = yyvsp[0].str; ;
    break;}
case 47:
#line 447 "ug_read.y"
{ yyval.str = NULL; ;
    break;}
case 48:
#line 448 "ug_read.y"
{ yyval.str = yyvsp[0].str; ;
    break;}
case 49:
#line 451 "ug_read.y"
{ yyval.str = NULL; ;
    break;}
case 50:
#line 452 "ug_read.y"
{ yyval.str = yyvsp[0].str; ;
    break;}
}

#line 606 "/usr/local/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (int) (sizeof (yytname) / sizeof (char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen (yytname[x]) + 15, count++;
	  size += strlen ("parse error, unexpected `") + 1;
	  size += strlen (yytname[YYTRANSLATE (yychar)]);
	  msg = (char *) malloc (size);
	  if (msg != 0)
	    {
	      strcpy (msg, "parse error, unexpected `");
	      strcat (msg, yytname[YYTRANSLATE (yychar)]);
	      strcat (msg, "'");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (int) (sizeof (yytname) / sizeof (char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat (msg, count == 0 ? ", expecting `" : " or `");
			strcat (msg, yytname[x]);
			strcat (msg, "'");
			count++;
		      }
		}
	      yyerror (msg);
	      free (msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#if YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#if YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 455 "ug_read.y"


/**  Function:    ug_parse(&uc, *filename)
 **  Description: Use this function, rather than calling ug_readparse()
 **    directly.  This sets up all of the defaults and prepares the
 **    datastructure for reading.
 **/
void ug_parse(ug_CADSpace &uc, char *filename)
{
  //int i;
  //ug_region *ur;

  region_name = NULL;
  line = 0;
  ucs = &uc;
  unnamed_unit = 0;

  ug_readin = fopen(filename, "r");
  if(ug_readin != NULL){
    cerr << "Reading from file: " << filename << endl;
    ug_readparse();
    cerr << "Done reading file." << endl;
    fclose(ug_readin);
  }else{
    cerr << "Couldn't read from file: " << filename << endl;
  }

  if(unnamed_unit > 0){
    cerr << "Named " << unnamed_unit << " wires and faces." << endl;
  }

  return;
}

